//
//  SBSDKMedicalCertificateRecognizerResult+JSON.swift
//  ScanbotSDKNativeWrapper
//
//  Created by Marco Saia on 23.09.22.
//
import Foundation
import ScanbotSDK

internal extension SBSDKMedicalCertificateRecognizerResult {
    
    func toSdkJson() -> [String: Any] {
        var jsonResult = [String:Any]()

        jsonResult["mcFormType"] = self.formType.stringName
        jsonResult["recognitionSuccessful"] = self.recognitionSuccessful

        // Patient Data
        var patientFieldsJson :[[String: Any?]] = []
        let patientFields  = self.patientFields ?? []
        for field in patientFields {
            let value = field.value
            patientFieldsJson.append( [
                "value": value,
                "patientInfoFieldType": field.type.stringName,
            ])
        }

        jsonResult["patientInfoFields"] = patientFieldsJson

        // Checkboxes
        var checkboxesJson : [[String: Any?]] = []
        self.checkboxes?.forEach {
            checkboxesJson.append( [
                "contentsValidationConfidenceValue": $0.confidenceValue,
                "hasContents": $0.isChecked,
                "subType": $0.type.stringName,
            ])
        }
        jsonResult["checkboxes"] = checkboxesJson

        // Dates
        var datesJson :[[String: Any?]] = []
        self.dates?.forEach {
            datesJson.append([
                "type": $0.dateRecordType.stringName,
                "dateString": $0.dateString ?? "",
                "recognitionConfidenceValue": $0.recognitionConfidence,
                "validationConfidenceValue": $0.validationConfidence
            ])
        }
        jsonResult["dates"] = datesJson

        return jsonResult
    }
    

}
