import 'package:flutter/cupertino.dart';

import 'classical_camera.dart';
import 'medical_certificate_live_detection.dart';
import 'medical_certificate_scanner_configuration.dart';

class MedicalCertificateScannerCamera extends StatelessWidget {
  const MedicalCertificateScannerCamera(
      {Key? key,
      required this.cameraDetector,
      required this.configuration,
      required this.onWidgetReady,
      this.onHeavyOperationProcessing})
      : super(key: key);

  final MedicalCertificateCameraLiveDetector cameraDetector;
  final MedicalCertificateCameraConfiguration configuration;
  final Function(ScanbotCameraController controller) onWidgetReady;

  /// Triggers when camera plugin make long work eg. saving snap to the image etc.
  final Function(bool)? onHeavyOperationProcessing;

  @override
  Widget build(BuildContext context) {
    var finder = configuration.finder;
    return Stack(
      children: [
        ScanbotCamera(
          detector: cameraDetector,
          // Here we set initial configurations of the camera
          configuration: configuration,
          onCameraReady: onWidgetReady,
          finder: finder,
          onHeavyOperationProcessing: onHeavyOperationProcessing,
        ),
      ],
    );
  }
}
